diff --git a/pithos-macos/pithos_macosAppDelegate.h b/pithos-macos/pithos_macosAppDelegate.h
index 16ad2da..3545189 100644
--- a/pithos-macos/pithos_macosAppDelegate.h
+++ b/pithos-macos/pithos_macosAppDelegate.h
@@ -38,39 +38,47 @@
 #import <Cocoa/Cocoa.h>
 @class PithosBrowserController;
 @class PithosPreferencesController;
-@class PithosSyncDaemon;
-@class ASIPithos;
+@class PithosAccount;
 
 @interface pithos_macosAppDelegate : NSObject <NSApplicationDelegate> {
     IBOutlet PithosBrowserController *pithosBrowserController;
     IBOutlet PithosPreferencesController *pithosPreferencesController;
     
-    PithosSyncDaemon *pithosSyncDaemon;
     BOOL alwaysNo;
     
-    ASIPithos *pithos;
-
     IBOutlet NSMenu *statusMenu;
+    IBOutlet NSMenu *accountsMenu;
+    IBOutlet NSMenu *lastSyncMenu;
     NSStatusItem *statusItem;
     
     NSString *aboutVersion;
     
     NSUserDefaults *userDefaults;
+    
+    BOOL activated;
+    PithosAccount *currentPithosAccount;
+    NSMutableArray *pithosAccounts;
+    NSMutableDictionary *pithosAccountsDictionary;
+    
+    NSTimeInterval syncTimeInterval;
+    NSTimer *syncTimer;
+    PithosAccount *syncPithosAccount;
 }
 
+@property (nonatomic, retain) PithosBrowserController *pithosBrowserController;
+@property (nonatomic, assign) BOOL alwaysNo;
+@property (nonatomic, readonly) NSString *aboutVersion;
+@property (nonatomic, assign) BOOL activated;
+@property (nonatomic, retain) PithosAccount *currentPithosAccount;
+@property (nonatomic, retain) NSMutableArray *pithosAccounts;
+@property (nonatomic, readonly) NSMutableDictionary *pithosAccountsDictionary;
+@property (nonatomic, retain) PithosAccount *syncPithosAccount;
+
 - (void)handleAppleEvent:(NSAppleEventDescriptor *)event withReplyEvent: (NSAppleEventDescriptor *)replyEvent;
 - (IBAction)showPithosBrowser:(id)sender;
 - (IBAction)showPithosPreferences:(id)sender;
 - (IBAction)aboutPithos:(id)sender;
-- (IBAction)syncNow:(id)sender;
-
-- (void)login;
-- (void)authenticate;
-
-@property (nonatomic, retain) ASIPithos *pithos;
-@property (nonatomic, retain) PithosBrowserController *pithosBrowserController;
-@property (nonatomic, retain) PithosSyncDaemon *pithosSyncDaemon;
-@property (nonatomic, assign) BOOL alwaysNo;
-@property (nonatomic, readonly) NSString *aboutVersion;
+- (void)savePithosAccounts:(id)sender;
+- (void)removedPithosAccount:(PithosAccount *)removedPithosAccount;
 
 @end
diff --git a/pithos-macos/pithos_macosAppDelegate.m b/pithos-macos/pithos_macosAppDelegate.m
index fda2640..e52fe17 100644
--- a/pithos-macos/pithos_macosAppDelegate.m
+++ b/pithos-macos/pithos_macosAppDelegate.m
@@ -36,79 +36,78 @@
 // or implied, of GRNET S.A.
 
 #import "pithos_macosAppDelegate.h"
+#import "PithosAccount.h"
 #import "PithosBrowserController.h"
 #import "PithosPreferencesController.h"
 #import "PithosSyncDaemon.h"
 #import "ASIPithosRequest.h"
 #import "ASIPithos.h"
 #import "ASIDownloadCache.h"
+#import "LastCompletedSyncTransformer.h"
 
 @implementation pithos_macosAppDelegate
-@synthesize pithos, pithosBrowserController, pithosSyncDaemon, alwaysNo, aboutVersion;
+@synthesize pithosBrowserController, alwaysNo, aboutVersion, activated, currentPithosAccount, pithosAccounts, pithosAccountsDictionary, syncPithosAccount;
 
 - (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
-    userDefaults = [[NSUserDefaults standardUserDefaults] retain];
-    NSString *stringURL;
-    NSURL *testURL;
+    [[NSAppleEventManager sharedAppleEventManager] setEventHandler:self 
+                                                       andSelector:@selector(handleAppleEvent:withReplyEvent:) 
+                                                     forEventClass:kInternetEventClass 
+                                                        andEventID:kAEGetURL];
     
-    stringURL = [userDefaults stringForKey:@"storageURLPrefix"];
-    testURL = (stringURL) ? [NSURL URLWithString:stringURL] : nil;
-    if (!testURL || !testURL.scheme || !testURL.host)
-        [userDefaults setObject:@"https://plus.pithos.grnet.gr/v1" forKey:@"storageURLPrefix"];
-
-    stringURL = [userDefaults stringForKey:@"publicURLPrefix"];
-    testURL = (stringURL) ? [NSURL URLWithString:stringURL] : nil;
-    if (!testURL || !testURL.scheme || !testURL.host)
-        [userDefaults setObject:@"https://plus.pithos.grnet.gr" forKey:@"publicURLPrefix"];
-        
-    stringURL = [userDefaults stringForKey:@"loginURLPrefix"];
-    testURL = (stringURL) ? [NSURL URLWithString:stringURL] : nil;
-    if (!testURL || !testURL.scheme || !testURL.host)
-        [userDefaults setObject:@"https://plus.pithos.grnet.gr/login" forKey:@"loginURLPrefix"];
+    userDefaults = [[NSUserDefaults standardUserDefaults] retain];
 
-    stringURL = [userDefaults stringForKey:@"aboutURL"];
-    testURL = (stringURL) ? [NSURL URLWithString:stringURL] : nil;
-    if (!testURL || !testURL.scheme || !testURL.host)
-        [userDefaults setObject:@"https://pithos.dev.grnet.gr/docs" forKey:@"aboutURL"];
+    NSString *stringURL = [userDefaults stringForKey:@"aboutURL"];
+    NSURL *testURL = (stringURL) ? [NSURL URLWithString:stringURL] : nil;
+    if (!testURL || !testURL.scheme || !testURL.host) {
+        [userDefaults setObject:@"https://pithos.dev.grnet.gr/docs/pithos" forKey:@"aboutURL"];
+        [userDefaults synchronize];
+    }
     
-    NSString *syncDirectoryPath = [userDefaults stringForKey:@"syncDirectoryPath"];
-    if (!syncDirectoryPath || ![syncDirectoryPath length]) {
-        syncDirectoryPath = [[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0] stringByAppendingPathComponent:@"Pithos"];
-    } else {
-        NSFileManager *fileManager = [NSFileManager defaultManager];
-        BOOL isDirectory;
-        BOOL fileExists = [fileManager fileExistsAtPath:syncDirectoryPath isDirectory:&isDirectory];
-        NSError *error = nil;
-        if ((fileExists && !isDirectory) || 
-            (!fileExists && (![fileManager createDirectoryAtPath:syncDirectoryPath withIntermediateDirectories:YES attributes:nil error:&error] || error))) {
-            syncDirectoryPath = [[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0] stringByAppendingPathComponent:@"Pithos"];
-        }   
+    syncTimeInterval = [userDefaults doubleForKey:@"syncTimeInterval"];
+    if (syncTimeInterval <= 0.0) {
+        syncTimeInterval = 180.0;
+        [userDefaults setDouble:syncTimeInterval forKey:@"syncTimeInterval"];
+        [userDefaults synchronize];
     }
-    [userDefaults setObject:syncDirectoryPath forKey:@"syncDirectoryPath"];
     
-    NSString *syncContainerName = [userDefaults stringForKey:@"syncContainerName"];
-    if (!syncContainerName || ![syncContainerName length] || [syncContainerName isEqualToString:@"trash"])
-        [userDefaults setObject:@"pithos" forKey:@"syncContainerName"];
-
-    double syncTimeInterval = [userDefaults doubleForKey:@"syncTimeInterval"];
-    if (syncTimeInterval <= 0)
-        [userDefaults setDouble:180.0 forKey:@"syncTimeInterval"];
+    NSData *tmpData = [userDefaults objectForKey:@"pithosAccounts"];
+    NSArray *tmpArray;
+    if (tmpData && (tmpArray = [NSKeyedUnarchiver unarchiveObjectWithData:tmpData]))
+        self.pithosAccounts = [NSMutableArray arrayWithArray:tmpArray];
+    else
+        self.pithosAccounts = [NSMutableArray array];
     
-    [userDefaults synchronize];
+    if (![pithosAccounts count]) {
+        [pithosAccounts addObject:[PithosAccount pithosAccount]];
+        self.pithosAccounts = self.pithosAccounts;
+    } else {
+        self.activated = YES;
+    }
     
-    [userDefaults addObserver:self 
-                   forKeyPath:@"syncDirectoryPath"
-                      options:NSKeyValueObservingOptionNew
-                      context:NULL];
-     
-    [[NSAppleEventManager sharedAppleEventManager] setEventHandler:self 
-                                                       andSelector:@selector(handleAppleEvent:withReplyEvent:) 
-                                                     forEventClass:kInternetEventClass 
-                                                        andEventID:kAEGetURL];
+    pithosAccountsDictionary = [[NSMutableDictionary alloc] initWithCapacity:[pithosAccounts count]];
+    for (PithosAccount *pithosAccount in pithosAccounts) {
+        [pithosAccountsDictionary setObject:pithosAccount forKey:pithosAccount.name];
+        if (!currentPithosAccount && pithosAccount.active)
+            currentPithosAccount = [pithosAccount retain];
+    }
+    if (!currentPithosAccount)
+        self.currentPithosAccount = [pithosAccounts objectAtIndex:0];
     
-    [self showPithosBrowser:self];
-    self.pithos = [ASIPithos pithos];
-    [self authenticate];
+    if (currentPithosAccount.active) {
+        [self savePithosAccounts:self];
+        [self showPithosBrowser:self];
+        pithosBrowserController.pithos = currentPithosAccount.pithos;
+    } else {
+        // XXX maybe call specifically to go to new account tab
+        [self showPithosPreferences:self];
+    }
+
+    syncTimer = [[NSTimer scheduledTimerWithTimeInterval:syncTimeInterval 
+                                                  target:self 
+                                                selector:@selector(sync) 
+                                                userInfo:nil 
+                                                 repeats:YES] retain];
+    [syncTimer fire];
 }
 
 // Based on: http://cocoatutorial.grapewave.com/2010/01/creating-a-status-bar-application/
@@ -135,9 +134,10 @@
     NSURL *url = [NSURL URLWithString:[[event paramDescriptorForKeyword:keyDirectObject] stringValue]];
     NSString *host = [url host];
 	NSString *query = [url query];
-    NSLog(@"host : '%@', query: '%@'", host, query);
+    PithosAccount *pithosAccount = [pithosAccountsDictionary objectForKey:[url lastPathComponent]];
     NSProcessInfo *processInfo = [NSProcessInfo processInfo];
-    if ([host isEqualToString:[NSString stringWithFormat:@"%@_%d", [processInfo processName], [processInfo processIdentifier]]] && query) {
+    if ([host isEqualToString:[NSString stringWithFormat:@"%@_%d", [processInfo processName], [processInfo processIdentifier]]] && 
+        pithosAccount && query) {
         // user=
         NSString *authUser;
         NSRange userRange = [query rangeOfString:@"user=" options:NSCaseInsensitiveSearch];
@@ -173,28 +173,40 @@
         
         NSLog(@"query authUser: '%@', authToken: '%@'", authUser, authToken);
         if ([authUser length] && [authToken length]) {
-            [userDefaults setObject:authUser forKey:@"authUser"];
-            [userDefaults setObject:authToken forKey:@"authToken"];
-            [userDefaults synchronize];
-
-            [self authenticate];
+            [pithosAccount authenticateWithServerURL:nil authUser:authUser authToken:authToken];
+            [self savePithosAccounts:self];
+            if (pithosPreferencesController && [pithosPreferencesController.selectedPithosAccount isEqualTo:pithosAccount]) {
+                pithosPreferencesController.authUser = pithosAccount.authUser;
+                pithosPreferencesController.authToken = pithosAccount.authToken;
+            }
+            self.activated = YES;
+            if ([pithosAccount isEqualTo:currentPithosAccount]) {
+                [self showPithosBrowser:self];
+                pithosBrowserController.pithos = pithosAccount.pithos;
+            }
         }
         // XXX else maybe show an error message?
     }
     // XXX else maybe show an error message?
 }
 
-#pragma mark -
-#pragma Observers
-
-- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context {
-    if ([object isEqualTo:userDefaults] && [keyPath isEqualToString:@"syncDirectoryPath"]) {
-        [self authenticate];
+- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender {
+    [self savePithosAccounts:self];
+    if ([self.pithosBrowserController operationsPending]) {
+        NSAlert *alert = [[[NSAlert alloc] init] autorelease];
+        [alert setMessageText:@"Pending Operations"];
+        [alert setInformativeText:@"There are pending operations in the browser, do you want to quit and cancel them?"];
+        [alert addButtonWithTitle:@"OK"];
+        [alert addButtonWithTitle:@"Cancel"];
+        NSInteger choice = [alert runModal];
+        if (choice == NSAlertSecondButtonReturn) 
+            return NSTerminateCancel;
     }
+    return NSTerminateNow;
 }
 
 #pragma mark -
-#pragma Properties
+#pragma mark Properties
 
 - (NSString *)aboutVersion {
     return [NSString stringWithFormat:@"About Pithos+ %@ (%@)", 
@@ -203,9 +215,52 @@
 }
 
 #pragma mark -
-#pragma Actions
+#pragma mark NSMenuDelegate
+
+- (void)menuNeedsUpdate:(NSMenu *)menu {
+    NSMenuItem *menuItem;
+    [menu removeAllItems];
+    if ([menu isEqualTo:accountsMenu]) {
+        [menu setAutoenablesItems:NO];
+        for (PithosAccount *pithosAccount in pithosAccounts) {
+            menuItem = [[[NSMenuItem alloc] initWithTitle:pithosAccount.name 
+                                                   action:@selector(menuChangePithosAccount:) 
+                                            keyEquivalent:@""] autorelease];
+            [menuItem setRepresentedObject:pithosAccount];
+            [menuItem setEnabled:pithosAccount.active];
+            [menuItem setState:((pithosAccount.active && [currentPithosAccount isEqualTo:pithosAccount]) ? NSOnState : NSOffState)];
+            [menu addItem:menuItem];
+        }
+    } else if ([menu isEqualTo:lastSyncMenu]) {
+        NSString *menuItemTitle;
+        [menu setAutoenablesItems:NO];
+        for (PithosAccount *pithosAccount in pithosAccounts) {
+            menuItemTitle = [NSString stringWithFormat:@"%@: %@", 
+                             pithosAccount.name, 
+                             [[[[LastCompletedSyncTransformer alloc] init] autorelease] transformedValue:pithosAccount.syncLastCompleted]];
+            if ([pithosAccount isEqualTo:syncPithosAccount] && [pithosAccount.syncDaemon isSyncing])
+                menuItemTitle = [menuItemTitle stringByAppendingString:@" (syncing)"];
+            menuItem = [[[NSMenuItem alloc] initWithTitle:menuItemTitle 
+                                                   action:@selector(menuChangeSyncActive:) 
+                                            keyEquivalent:@""] autorelease];
+            [menuItem setRepresentedObject:pithosAccount];
+            [menuItem setEnabled:pithosAccount.active];
+            [menuItem setState:((pithosAccount.active && pithosAccount.syncActive) ? NSOnState : NSOffState)];
+            [menu addItem:menuItem];
+        }
+        [menu addItem:[NSMenuItem separatorItem]];
+        [menu addItem:[[[NSMenuItem alloc] initWithTitle:@"Next Sync" 
+                                                  action:@selector(sync) 
+                                           keyEquivalent:@""] autorelease]];
+    }
+}
+
+#pragma mark -
+#pragma mark Actions
 
 - (IBAction)showPithosBrowser:(id)sender {
+    if (!activated)
+        return;
     [pithosBrowserController showWindow:sender];
     [[pithosBrowserController window] makeKeyAndOrderFront:sender];
     [NSApp activateIgnoringOtherApps:YES];
@@ -221,61 +276,131 @@
     [[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:[userDefaults stringForKey:@"aboutURL"]]];
 }
 
-- (IBAction)syncNow:(id)sender {
-    [pithosSyncDaemon sync];
+- (void)sync {
+    if (!activated || ![pithosAccounts count])
+        return;
+    NSUInteger syncIndex;
+    BOOL syncPithosAccountFound = [pithosAccounts containsObject:syncPithosAccount];
+    if (syncPithosAccountFound)
+         syncIndex = [pithosAccounts indexOfObject:syncPithosAccount];
+    
+    PithosAccount *singleSyncPithosAccount = nil;
+    for (PithosAccount *pithosAccount in pithosAccounts) {
+        if (!singleSyncPithosAccount && pithosAccount.active && pithosAccount.syncActive && pithosAccount.syncDaemon) {
+            singleSyncPithosAccount = pithosAccount;
+        } else if (singleSyncPithosAccount && pithosAccount.active && pithosAccount.syncActive && pithosAccount.syncDaemon) {
+            singleSyncPithosAccount = nil;
+            break;
+        }
+    }
+    
+    if (syncPithosAccount && syncPithosAccount.active && syncPithosAccount.syncActive && syncPithosAccount.syncDaemon) {
+        // An active syncDaemon was previously syncing
+        if (singleSyncPithosAccount && [singleSyncPithosAccount isEqualTo:syncPithosAccount]) {
+            // It's the only one, sync again
+            [syncPithosAccount.syncDaemon startDaemon];
+            [syncPithosAccount.syncDaemon sync];
+            return;
+        } else if ([syncPithosAccount.syncDaemon isSyncing]) {
+            // It's still syncing, mark it as late and return
+            [syncPithosAccount.syncDaemon syncLate];
+            return;
+        }
+    }
+    PithosAccount *newSyncPithosAccount = nil;
+    if (syncPithosAccountFound) {
+        for (PithosAccount *pithosAccount in [pithosAccounts objectsAtIndexes:[NSIndexSet indexSetWithIndexesInRange:NSMakeRange(syncIndex + 1, [pithosAccounts count] - syncIndex - 1)]]) {
+            if (pithosAccount.active && pithosAccount.syncActive && pithosAccount.syncDaemon) {
+                newSyncPithosAccount = pithosAccount;
+                break;
+            }
+        }
+        if (!newSyncPithosAccount) {
+            for (PithosAccount *pithosAccount in [pithosAccounts objectsAtIndexes:[NSIndexSet indexSetWithIndexesInRange:NSMakeRange(0, syncIndex)]]) {
+                if (pithosAccount.active && pithosAccount.syncActive && pithosAccount.syncDaemon) {
+                    newSyncPithosAccount = pithosAccount;
+                    break;
+                }
+            }
+        }
+    } else {
+        for (PithosAccount *pithosAccount in pithosAccounts) {
+            if (pithosAccount.active && pithosAccount.syncActive && pithosAccount.syncDaemon) {
+                newSyncPithosAccount = pithosAccount;
+                break;
+            }
+        }
+    }        
+    if (newSyncPithosAccount) {
+        // A different syncDaemon is found, sync it
+        self.syncPithosAccount = newSyncPithosAccount;
+        [syncPithosAccount.syncDaemon startDaemon];
+        [syncPithosAccount.syncDaemon sync];
+    } else if (syncPithosAccountFound && syncPithosAccount && syncPithosAccount.active && syncPithosAccount.syncActive && syncPithosAccount.syncDaemon) {
+        [syncPithosAccount.syncDaemon startDaemon];
+        [syncPithosAccount.syncDaemon sync];
+    } else {
+        self.syncPithosAccount = nil;
+    }
 }
 
-#pragma mark -
-#pragma Authentication
+- (void)savePithosAccounts:(id)sender {
+    [userDefaults setObject:[NSKeyedArchiver archivedDataWithRootObject:pithosAccounts] forKey:@"pithosAccounts"];
+    [userDefaults synchronize];
+}
 
-- (void)login {
-    NSProcessInfo *processInfo = [NSProcessInfo processInfo];
-    NSString *loginURL = [NSString stringWithFormat:@"%@?next=pithos://%@_%d", 
-                          [userDefaults stringForKey:@"loginURLPrefix"], [processInfo processName], [processInfo processIdentifier]];
-    NSLog(@"loginURL: %@", loginURL);
-    [[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:loginURL]];
+- (void)removedPithosAccount:(PithosAccount *)removedPithosAccount {
+    if ([self.currentPithosAccount isEqualTo:removedPithosAccount]) {
+        for (PithosAccount *pithosAccount in pithosAccounts) {
+            if (pithosAccount.active) {
+                self.currentPithosAccount = pithosAccount;
+                pithosBrowserController.pithos = currentPithosAccount.pithos;
+                break;
+            }
+        }
+        if ([self.currentPithosAccount isEqualTo:removedPithosAccount]) {
+            self.activated = NO;
+            [pithosBrowserController.window close];
+            [pithosBrowserController resetBrowser];
+            self.currentPithosAccount = [pithosAccounts objectAtIndex:0];
+        }
+    }
+    if ([self.syncPithosAccount isEqualTo:removedPithosAccount])
+        self.syncPithosAccount = nil;
 }
 
-- (void)authenticate {
-    NSString *authUser = [userDefaults stringForKey:@"authUser"];
-    NSString *authToken = [userDefaults stringForKey:@"authToken"];
-    NSString *storageURLPrefix = [userDefaults stringForKey:@"storageURLPrefix"];
-    NSString *publicURLPrefix = [userDefaults stringForKey:@"publicURLPrefix"];
-    NSString *syncDirectoryPath = [userDefaults stringForKey:@"syncDirectoryPath"];
-    NSString *syncContainerName = [userDefaults stringForKey:@"syncContainerName"];
-    double syncTimeInterval = [userDefaults doubleForKey:@"syncTimeInterval"];
-    NSLog(@"Authentication - storageURLPrefix:%@, authUser:%@, authToken:%@", storageURLPrefix, authUser, authToken);
-    if (([authUser length] == 0) || ([authToken length] == 0)) {
-        [self showPithosPreferences:self];
-    } else if ([authUser length] && [authToken length] && 
-               (![pithos.authUser isEqualToString:authUser] || ![pithos.authToken isEqualToString:authToken])) {
-        [userDefaults setObject:authUser forKey:@"previousAuthUser"];
-        [userDefaults setObject:authToken forKey:@"previousAuthToken"];
-        
-        [[ASIDownloadCache sharedCache] clearCachedResponsesForStoragePolicy:ASICacheForSessionDurationCacheStoragePolicy];
-        [[ASIPithosRequest sharedQueue] cancelAllOperations];
-        
-        ASIPithos *newPithos = [ASIPithos pithos];
-        newPithos.authURL = storageURLPrefix;
-        newPithos.storageURLPrefix = storageURLPrefix;
-        newPithos.authUser = authUser;
-        newPithos.authToken = authToken;
-        newPithos.publicURLPrefix = publicURLPrefix;
-        self.pithos = newPithos;
-        
-        pithosBrowserController.pithos = pithos;
-        self.pithosSyncDaemon = [[[PithosSyncDaemon alloc] initWithDirectoryPath:syncDirectoryPath 
-                                                                          pithos:pithos
-                                                                   containerName:syncContainerName 
-                                                                    timeInterval:syncTimeInterval 
-                                                                 resetLocalState:NO] autorelease];
-    } else if (![pithosSyncDaemon.directoryPath isEqualToString:syncDirectoryPath]) {
-        self.pithosSyncDaemon = [[[PithosSyncDaemon alloc] initWithDirectoryPath:syncDirectoryPath 
-                                                                          pithos:pithos
-                                                                   containerName:syncContainerName 
-                                                                    timeInterval:syncTimeInterval 
-                                                                 resetLocalState:YES] autorelease];
+#pragma mark -
+#pragma mark Menu Actions
+
+- (void)menuChangePithosAccount:(NSMenuItem *)sender {
+    PithosAccount *pithosAccount = (PithosAccount *)[sender representedObject];
+    if (!pithosAccount.active)
+        return;
+    if (![currentPithosAccount isEqualTo:pithosAccount] && [pithosAccounts containsObject:pithosAccount]) {
+        if ([self.pithosBrowserController operationsPending]) {
+            NSAlert *alert = [[[NSAlert alloc] init] autorelease];
+            [alert setMessageText:@"Pending Operations"];
+            [alert setInformativeText:@"There are pending operations in the browser, do you want to change accounts and cancel them?"];
+            [alert addButtonWithTitle:@"OK"];
+            [alert addButtonWithTitle:@"Cancel"];
+            NSInteger choice = [alert runModal];
+            if (choice == NSAlertSecondButtonReturn) 
+                return;
+        }
+        self.currentPithosAccount = pithosAccount;
+        [self showPithosBrowser:self];
+        pithosBrowserController.pithos = currentPithosAccount.pithos;
     }
 }
 
+- (void)menuChangeSyncActive:(NSMenuItem *)sender {
+    PithosAccount *pithosAccount = (PithosAccount *)[sender representedObject];
+    if (!pithosAccount.active)
+        return;
+    pithosAccount.syncActive = !pithosAccount.syncActive;
+    if (pithosPreferencesController && [pithosPreferencesController.selectedPithosAccount isEqualTo:pithosAccount])
+        pithosPreferencesController.syncActive = pithosAccount.syncActive;
+    [self savePithosAccounts:self];
+}
+
 @end
